import greenfoot.Actor;
import greenfoot.MouseInfo;
import greenfoot.*;
import java.util.ArrayList;
import java.awt.Point;
import java.util.List;
/**
 * Turtle
 * 
 * @author Taylor Born
 * @version January 20100
 */
public class Ghost  extends Actor
{
    private ArrayList<Square> sqrList; // Squares that are looked at
    private ArrayList<Square> myRoute; // My charted course
    private int routeIndex; // How far I've gone on my route
    private int parent; // Square that gets me to another square
    private boolean target; // If found destination
    private Point targetDestination; // Where I want to go
    private int step = 0; // Slow down travel speed
    private boolean moveToWord = true;
    int stepFood = 1;
    
    private static final int CODE_ID = 71;
    
    public int ghostScore = 0;
    private int foodEaten;
    String[] bag1 = new String[]{null, null, null, null, null, null};  
    boolean[] bag2 = new boolean[]{false,false,false,false,false,false};
            int asdf = 0;
    
    public String textPac[][] = {{"C","A","T"},{"B","A","T"},{"A","N","T"},{"P","I","G"},{"R","A","T"},{"B","I","G"},{"R","E","D"},{"A","R","M"},{"C","A","R"},{"L","E","G"},{"A","I","R"},{"T","E","A"},{"S","E","A"},{"B","O","W"},{"A","R","T"},{"S","I","N"},{"I","C","E"},{"B","U","S"},{"G","A","S"}};
    public String textAI[][] = {{"C","A","T"},{"B","A","T"},{"A","N","T"},{"P","I","G"},{"R","A","T"},{"B","I","G"},{"R","E","D"},{"A","R","M"},{"C","A","R"},{"L","E","G"},{"A","I","R"},{"T","E","A"},{"S","E","A"},{"B","O","W"},{"A","R","T"},{"S","I","N"},{"I","C","E"},{"B","U","S"},{"G","A","S"}};
    private boolean checkPac[] = {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true};
    
    int numAI = 0;
    boolean textPac1[] = {false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
    public String textLine[] = {"C","A","T","B","A","T","A","N","T","P","I","G","R","A","T","B","I","G","R","E","D","A","R","M","C","A","R","L","E","G"};
    boolean checkShow[] = {false,false,false,false,false,false};
    int nowShow[] = {0,0,0,0,0,0};
    Word sss;
    
    int countaa = 0;
    
    public int totalScore;
    
     // java.util.List<Word> wordInWorld = getWorld().getObjects(Word.class);
    
    public Ghost(int x, int y)
    {
        targetDestination = new Point(x, y); // Where I want to be
    }
    public Ghost()
    {
        
    }
    public void findPath(Point pPosition, Point startPosition)
    {
        targetDestination = pPosition; // Get destination
        sqrList = new ArrayList<Square>(); // Refresh my squares to look at
        sqrList.add(new Square(startPosition, -1, 0, 0, targetDestination)); // Add my current position as a square to look at
        target = false; // I have just begun
        parent = 0; // Start at first square
    }
    public void move(int x, int y)
    {
        targetDestination = new Point(x,y);
        Point startPosition = new Point(getX(), getY());
        sqrList = new ArrayList<Square>(); // Refresh my squares to look at
        sqrList.add(new Square(startPosition, -1, 0, 0, targetDestination)); // Add my current position as a square to look at
        target = false; // I have just begun
        parent = 0; // Start at first square
    }
    public void move(Word word)
    {
        int x = word.getX();
        int y = word.getY();
        targetDestination = new Point(x,y);
        Point startPosition = new Point(getX(), getY());
        sqrList = new ArrayList<Square>(); // Refresh my squares to look at
        sqrList.add(new Square(startPosition, -1, 0, 0, targetDestination)); // Add my current position as a square to look at
        target = false; // I have just begun
        parent = 0; // Start at first square
    }private void makePath()
    {
        for (int q = 0; q < 50 && !target; q++) // Do so many calculations per act so not to lag other parts of the program
        {
            // Check all squares around the currently looked at square
            // Square to the left
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() - 2, sqrList.get(parent).getY(), Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(-1, 0))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() - 1, sqrList.get(parent).getY()), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square to the upper left
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() - 2, sqrList.get(parent).getY() - 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() - 1 > -1 && sqrList.get(parent).getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(-1, -1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() - 1, sqrList.get(parent).getY() - 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            // Square above
            if (getWorld().getObjectsAt(sqrList.get(parent).getX(), sqrList.get(parent).getY() - 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(0, -1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX(), sqrList.get(parent).getY() - 1), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square to the upper right
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() + 2, sqrList.get(parent).getY() - 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() + 1 < 100 && sqrList.get(parent).getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(1, -1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() + 1, sqrList.get(parent).getY() - 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() + 2, sqrList.get(parent).getY(), Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(1, 0))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() + 1, sqrList.get(parent).getY()), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() + 2, sqrList.get(parent).getY() + 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() + 1 < 100 && sqrList.get(parent).getY() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(1, 1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() + 1, sqrList.get(parent).getY() + 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX(), sqrList.get(parent).getY() + 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getY() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(0, 1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX(), sqrList.get(parent).getY() + 1), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() - 2, sqrList.get(parent).getY() + 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() - 1 > -1 && sqrList.get(parent).getY() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(-1, 1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() - 1, sqrList.get(parent).getY() + 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            sqrList.get(parent).close(); // Done looking at this square
            int lowest = -1; // Index for square that has lowest score
            for (int i = 0; i < sqrList.size(); i++) // Get square that has lowest score
            {
                if (!sqrList.get(i).isClosed()) // Make sure we have not already looked at
                {
                    if (lowest == -1) // If havn't found one yet
                        lowest = i; // This lowest one found so far
                    else if (sqrList.get(i).getG() + sqrList.get(i).getH() < sqrList.get(lowest).getG() + sqrList.get(lowest).getH()) // Check to see if score of this square is the new lowest
                        lowest = i; // This lowest one found so far
                }
            }
            if (lowest == -1) // No possible path
            {
                targetDestination = new Point(getX(), getY());
                return;
            }
            parent = lowest; // Now looking at new lowest
            for (int i = 0; i < sqrList.size(); i++) // Loop all squares that have found
            {
                if (sqrList.get(i).getPosition().equals(targetDestination) && sqrList.get(i).isClosed()) // Check to see if found destination
                {
                    parent = i; // Start at this square to chart back to beginning
                    target = true; // We have found the destination
                }
            }
        }
        if (target) // If found destination
        {
            myRoute = new ArrayList<Square>(); // Refresh route to take
            while (parent != -1) // Loop till back to beginning
            {
                myRoute.add(sqrList.get(parent)); // Add square
                parent = sqrList.get(parent).getParent(); // Move to that square's parent
            }
            routeIndex = myRoute.size() - 2; // When start to move, starting at beginning
        }
    }
    private boolean check(int parent, int cost, Point spot)
    {
        boolean flag = false;
        for (int i = 0; i < sqrList.size(); i++) // Loop squares found
        {
            if (sqrList.get(i).getPosition().equals(new Point((int)(sqrList.get(parent).getX() + spot.getX()), (int)(sqrList.get(parent).getY() + spot.getY())))) // Check if already have the square
            {
                flag = true; // Do have this square
                if (!sqrList.get(i).isClosed() && sqrList.get(parent).getG() + cost < sqrList.get(i).getG()) // Check if new route to square is better
                {
                    sqrList.get(i).adopt(parent); // Change square's parent
                    sqrList.get(i).changeG(sqrList.get(parent).getG() + cost); // Change square's score
                }
            }
        }
        return flag; // return if found that already have square
    }
    public void setLocation(int x, int y)
    {
        if (targetDestination.getX() == getX() && targetDestination.getY() == getY())
            targetDestination = new Point(x, y);
        super.setLocation(x, y);
    }
    
    public void removeWord()
    {
        //getWorld().removeObjects(getWorld().getObjectsAt(Word.class));
        getWorld().removeObjects(getWorld().getObjectsAt(getX(), getY(),Word.class));
        moveToWord = true;
    }
    
    private void eatFood()
    {
        Actor a = getOneObjectAtOffset(0,0, A.class);
        Actor b = getOneObjectAtOffset(0,0, B.class);
        Actor c = getOneObjectAtOffset(0,0, C.class);
        Actor d = getOneObjectAtOffset(0,0, D.class);
        Actor e = getOneObjectAtOffset(0,0, E.class);
        Actor f = getOneObjectAtOffset(0,0, F.class);
        Actor g = getOneObjectAtOffset(0,0, G.class);
        Actor h = getOneObjectAtOffset(0,0, H.class);
        Actor i = getOneObjectAtOffset(0,0, I.class);
        Actor j = getOneObjectAtOffset(0,0, J.class);
        Actor k = getOneObjectAtOffset(0,0, K.class);
        Actor l = getOneObjectAtOffset(0,0, L.class);
        Actor m = getOneObjectAtOffset(0,0, M.class);
        Actor n = getOneObjectAtOffset(0,0, N.class);
        Actor o = getOneObjectAtOffset(0,0, O.class);
        Actor p = getOneObjectAtOffset(0,0, P.class);
        Actor q = getOneObjectAtOffset(0,0, Q.class);
        Actor r = getOneObjectAtOffset(0,0, R.class);
        Actor s = getOneObjectAtOffset(0,0, S.class);
        Actor t = getOneObjectAtOffset(0,0, T.class);
        Actor u = getOneObjectAtOffset(0,0, U.class);
        Actor v = getOneObjectAtOffset(0,0, V.class);
        Actor w = getOneObjectAtOffset(0,0, W.class);
        Actor x = getOneObjectAtOffset(0,0, X.class);
        Actor y = getOneObjectAtOffset(0,0, Y.class);
        Actor z = getOneObjectAtOffset(0,0, Z.class);
        //totalScore=totalScore;
        Chart paw=(Chart) getWorld();
        int bagLeft = checkBag();
        
        
        if(a!=null) { if(bagLeft<7){getWorld().removeObject(a);collectAlphabet(bagLeft,"a","A");foodEaten = foodEaten+5;}}
        else if(b!=null) { if(bagLeft<7){getWorld().removeObject(b);collectAlphabet(bagLeft,"b","B");foodEaten = foodEaten+5;}}
        else if(c!=null) { if(bagLeft<7){getWorld().removeObject(c);collectAlphabet(bagLeft,"c","C");foodEaten = foodEaten+5;}}
        else if(d!=null) { if(bagLeft<7){getWorld().removeObject(d);collectAlphabet(bagLeft,"d","D");foodEaten = foodEaten+5;}}
        else if(e!=null) { if(bagLeft<7){getWorld().removeObject(e);collectAlphabet(bagLeft,"e","E");foodEaten = foodEaten+5;}}
        else if(f!=null) { if(bagLeft<7){getWorld().removeObject(f);collectAlphabet(bagLeft,"f","F");foodEaten = foodEaten+5;}}
        else if(g!=null) { if(bagLeft<7){getWorld().removeObject(g);collectAlphabet(bagLeft,"g","G");foodEaten = foodEaten+5;}}
        else if(h!=null) { if(bagLeft<7){getWorld().removeObject(h);collectAlphabet(bagLeft,"h","H");foodEaten = foodEaten+5;}}
        else if(i!=null) { if(bagLeft<7){getWorld().removeObject(i);collectAlphabet(bagLeft,"i","I");foodEaten = foodEaten+5;}}
        else if(j!=null) { if(bagLeft<7){getWorld().removeObject(j);collectAlphabet(bagLeft,"j","J");foodEaten = foodEaten+5;}}
        else if(k!=null) { if(bagLeft<7){getWorld().removeObject(k);collectAlphabet(bagLeft,"k","K");foodEaten = foodEaten+5;}}
        else if(l!=null) { if(bagLeft<7){getWorld().removeObject(l);collectAlphabet(bagLeft,"l","L");foodEaten = foodEaten+5;}}
        else if(m!=null) { if(bagLeft<7){getWorld().removeObject(m);collectAlphabet(bagLeft,"m","M");foodEaten = foodEaten+5;}}
        else if(n!=null) { if(bagLeft<7){getWorld().removeObject(n);collectAlphabet(bagLeft,"n","N");foodEaten = foodEaten+5;}}
        else if(o!=null) { if(bagLeft<7){getWorld().removeObject(o);collectAlphabet(bagLeft,"o","O");foodEaten = foodEaten+5;}}
        else if(p!=null) { if(bagLeft<7){getWorld().removeObject(p);collectAlphabet(bagLeft,"p","P");foodEaten = foodEaten+5;}}
        else if(q!=null) { if(bagLeft<7){getWorld().removeObject(q);collectAlphabet(bagLeft,"q","Q");foodEaten = foodEaten+5;}}
        else if(r!=null) { if(bagLeft<7){getWorld().removeObject(r);collectAlphabet(bagLeft,"r","R");foodEaten = foodEaten+5;}}
        else if(s!=null) { if(bagLeft<7){getWorld().removeObject(s);collectAlphabet(bagLeft,"s","S");foodEaten = foodEaten+5;}}
        else if(t!=null) { if(bagLeft<7){getWorld().removeObject(t);collectAlphabet(bagLeft,"t","T");foodEaten = foodEaten+5;}}
        else if(u!=null) { if(bagLeft<7){getWorld().removeObject(u);collectAlphabet(bagLeft,"u","U");foodEaten = foodEaten+5;}}
        else if(v!=null) { if(bagLeft<7){getWorld().removeObject(v);collectAlphabet(bagLeft,"v","V");foodEaten = foodEaten+5;}}
        else if(w!=null) { if(bagLeft<7){getWorld().removeObject(w);collectAlphabet(bagLeft,"w","W");foodEaten = foodEaten+5;}}
        else if(x!=null) { if(bagLeft<7){getWorld().removeObject(x);collectAlphabet(bagLeft,"x","X");foodEaten = foodEaten+5;}}
        else if(y!=null) { if(bagLeft<7){getWorld().removeObject(y);collectAlphabet(bagLeft,"y","Y");foodEaten = foodEaten+5;}}
        else if(z!=null) { if(bagLeft<7){getWorld().removeObject(z);collectAlphabet(bagLeft,"z","Z");foodEaten = foodEaten+5;}}
        else {
            
        }
        
                    moveToWord = true;

    }
    
    private int checkBag(){
        if(bag2[0] == false){
            return 0;
        }
        else if(bag2[1] == false){
            return 1;
        }
        else if(bag2[2] == false){
            return 2;
        }
        else if(bag2[3] == false){
            return 3;
        }
        else if(bag2[4] == false){
            return 4;
        }
        else if(bag2[5] == false){
            return 5;
        }else
        return 7;
                    
    }
    
    private void collectAlphabet(int num,String asd,String orderAlphabet){
        switch(num+1){
                    case 1: getWorld().addObject(new WordFake(asd), 73, 15);
                            bag1[0] = orderAlphabet;
                            bag2[0] = true;
                    break;
                    case 2: getWorld().addObject(new WordFake(asd), 73, 20);
                            bag1[1] = orderAlphabet;
                            bag2[1] = true;
                    break;
                    case 3: getWorld().addObject(new WordFake(asd), 73, 25);
                            bag1[2] = orderAlphabet;
                            bag2[2] = true;
                    break;
                    case 4: getWorld().addObject(new WordFake(asd), 73, 30);
                            bag1[3] = orderAlphabet;
                            bag2[3] = true;
                    break;
                    case 5: getWorld().addObject(new WordFake(asd), 73, 35);
                            bag1[4] = orderAlphabet;
                            bag2[4] = true;
                    break;
                    case 6: getWorld().addObject(new WordFake(asd), 73, 40);
                            bag1[5] = orderAlphabet;
                            bag2[5] = true;
                    break;
        }

    }
    
    private void dropAlphabet(int x){
        //List fruit; 
        //Actor sq;
        //sq = getOneObjectAtOffset(0,0,sq.class);
        
        //fruit = getOneObjectAtOffset(0,0, sq.class);
        //Player py1 = new Player();
        //if(bag.get(x-1) != null){
            //isEat = false;
        //if(Fruit != null){
        //if(sq != null){        
        bag1[x] = null;
        bag2[x] = false;
            //getWorld().removeObjects(fruit);
            
       switch(x+1){
           case 1:
           getWorld().removeObjects(getWorld().getObjectsAt(73, 15,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 2:
           getWorld().removeObjects(getWorld().getObjectsAt(73, 20,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 3:
           getWorld().removeObjects(getWorld().getObjectsAt(73, 25,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 4:
           getWorld().removeObjects(getWorld().getObjectsAt(73, 30,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 5:
           getWorld().removeObjects(getWorld().getObjectsAt(73, 35,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 6:
           getWorld().removeObjects(getWorld().getObjectsAt(73, 40,WordFake.class));
           foodEaten = foodEaten-10;
           break;
       }
       // }
                
            //getWorld().addObject(new Fruit(), getX(),getY());
        //}
            //cooldown(5);
        //}
    }
    
    public void checkWord(String p,String q,String r,int d){
        for(int x=0; x<bag1.length; x++) {
            if(bag1[x] == p){
            
                for(int y=0; y<bag1.length;y++){
                    
                    if(bag1[y] == q){
                    
                        for(int z=0; z<bag1.length;z++){
                            if(bag1[z] == r){
                                
                                dropAlphabet(x);dropAlphabet(y);dropAlphabet(z);dropWord(d);checkShow[d] = false;
                                totalScore = totalScore+1;
                                
                            }
                        }
                    }
               }
            }
       } 
       
    }
    
    
    private void showWord(){
        int showLeft = checkShow();
        int wordLeft = checkWordLeft();
        if(showLeft >= 0&&wordLeft>=0){
            switch(showLeft+1){
                case 1:
                //show text
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[0] = wordLeft;
                
                //TextBar
                //getWorld().addObject(new TextBar(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2]),920,160);
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],92,16);
                break;
                
                case 2:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[1] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],92,21);
                break;
                
                case 3:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[2] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],92,26);
                break;
                
                case 4:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[3] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],92,31);
                break;
                
                case 5:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[4] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],92,36);
                break;
                
                case 6:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[5] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],92,41);
                break;
            }
        }
        
    }
    
    private int checkShow(){
        for(int x=0;x<checkShow.length;x++){
            if(checkShow[x] == false){
                return x;
            }
        }
        return -1;
    }
    
    private boolean checkNow(int x){
        if(checkShow[x] == true){
            return true;
        }
        return false;
    }
    
    private int checkWordLeft(){
        for(int x=0;x<textPac1.length;x++){
            if(textPac1[x] == false){
                return x;
            }
        }
        return -1;
    }
    
    public void autoCheckWord(){
        if(checkShow[0] == true ){
            checkWord(textPac[nowShow[0]][0],textPac[nowShow[0]][1],textPac[nowShow[0]][2],0);
            //checkWord(textPac[nowShow[1]][0],textPac[nowShow[1]][1],textPac[nowShow[1]][2],1);
            //checkShow[0] = false;
        }
        if(checkShow[1] == true ){
            checkWord(textPac[nowShow[1]][0],textPac[nowShow[1]][1],textPac[nowShow[1]][2],1);
            //checkShow[1]= false;
        }
        if(checkShow[2] == true ){
            checkWord(textPac[nowShow[2]][0],textPac[nowShow[2]][1],textPac[nowShow[2]][2],2);
            //checkShow[2]= false;
        }
        if(checkShow[3] == true ){
            checkWord(textPac[nowShow[3]][0],textPac[nowShow[3]][1],textPac[nowShow[3]][2],3);
            //checkShow[3]= false;
        }
        if(checkShow[4] == true ){
            checkWord(textPac[nowShow[4]][0],textPac[nowShow[4]][1],textPac[nowShow[4]][2],4);
            //checkShow[4]= false;
        }
        if(checkShow[5] == true ){
            checkWord(textPac[nowShow[5]][0],textPac[nowShow[5]][1],textPac[nowShow[5]][2],5);
            //checkShow[5]= false;
        }
    }
    
    public void dropWord(int x){
        switch(x+1){
           case 1:
           getWorld().showText(" ",92,16);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,160,null));
           break;
           case 2:
           getWorld().showText(" ",92,21);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,210,null));
           break;
           case 3:
           getWorld().showText(" ",92,26);
           //getWorld().removeObjects(getWorld().getObjectsAt(920,360,null));
           break;
           case 4:
           getWorld().showText(" ",92,31);
           //getWorld().removeObjects(getWorld().getObjectsAt(920,410,null));
           break;
           case 5:
           getWorld().showText(" ",92,36);
           //getWorld().removeObjects(getWorld().getObjectsAt(920,460,null));
           break;
           case 6:
           getWorld().showText(" ",92,41);
           //getWorld().removeObjects(getWorld().getObjectsAt(920,510,null));
           break;
       }
    }
    
    private void autoDeleteBag()
    {
       if(checkBag()==7){
           for(int x=0;x<6;x++){
               dropAlphabet(x);
           }
       }
    }
    
    private void chooseAI()
    {
       int choose=0;
       java.util.List<Word> a = getWorld().getObjects(Word.class);
       for(int x=0; x<textPac.length; x++) {
           for(int y=0; y<textPac[y].length; y++){
               for(int z=0; z<a.size(); z++){
                   if(a.get(z).getClass().getName ()==textPac[x][y]){
                       choose++;
                   }
                   else if(choose>=3){
                      chooseWordAI(x);
                    }
                }
            }
       }
       
       int choose1=0;
       for(int bag=0; bag<bag1.length;bag++){
           for(int x=0; x<textPac.length; x++) {
               for(int y=0; y<textPac[y].length; y++){ 
                   if(bag1[bag]==textPac[x][y]){
                       choose1++;
                   }
                   else if(choose1>=2){
                      for(int z=0; z<a.size(); z++){
                          if(a.get(z).getClass().getName()==textPac[x][y]){
                              choose1++;findShortest(a.get(z).getClass());
                          }
                          
                      }
                   }
               }
           }
       }
       
    }
    
    
      
    private void autoOn(){
        
    }
    
    private void chooseWordAI(int x){
        
        //int a =0;
        //for(int a =0;a<textPac[0].length;a++){
        if(stepFood == 1){
            String s = textPac[x][0];
            //Word c = Word.forName(""+s);
            //findShortest(c);
            //int si = Integer.parseInt(s);
            
            if(s=="A"){  findShortest(A.class); }
            else if(s=="B"){ findShortest(B.class); }
            else if(s=="C"){ findShortest(C.class); }
            else if(s=="D"){ findShortest(D.class); }
            else if(s=="F"){ findShortest(F.class); }
            else if(s=="G"){ findShortest(G.class); }
            else if(s=="H"){ findShortest(H.class); }
            else if(s=="I"){ findShortest(I.class); }
            else if(s=="J"){ findShortest(J.class); }
            else if(s=="K"){ findShortest(K.class); }
            else if(s=="L"){ findShortest(L.class); }
            else if(s=="M"){ findShortest(M.class); }
            else if(s=="N"){ findShortest(N.class); }
            else if(s=="O"){ findShortest(O.class); }
            else if(s=="P"){ findShortest(P.class); }
            else if(s=="Q"){ findShortest(Q.class); }
            else if(s=="R"){ findShortest(R.class); }
            else if(s=="S"){ findShortest(S.class); }
            else if(s=="T"){ findShortest(T.class); }
            else if(s=="U"){ findShortest(U.class); }
            else if(s=="V"){ findShortest(V.class); }
            else if(s=="W"){ findShortest(W.class); }
            else if(s=="X"){ findShortest(X.class); }
            else if(s=="Y"){ findShortest(Y.class); }
            else if(s=="Z"){ findShortest(Z.class); }
            else if(s=="E"){ findShortest(E.class); }
            stepFood++;
            
            
        }
        else if(stepFood == 2){
            String s = textPac[x][1];
            if(s=="A"){  findShortest(A.class); }
            else if(s=="B"){ findShortest(B.class); }
            else if(s=="C"){ findShortest(C.class); }
            else if(s=="D"){ findShortest(D.class); }
            else if(s=="F"){ findShortest(F.class); }
            else if(s=="G"){ findShortest(G.class); }
            else if(s=="H"){ findShortest(H.class); }
            else if(s=="I"){ findShortest(I.class); }
            else if(s=="J"){ findShortest(J.class); }
            else if(s=="K"){ findShortest(K.class); }
            else if(s=="L"){ findShortest(L.class); }
            else if(s=="M"){ findShortest(M.class); }
            else if(s=="N"){ findShortest(N.class); }
            else if(s=="O"){ findShortest(O.class); }
            else if(s=="P"){ findShortest(P.class); }
            else if(s=="Q"){ findShortest(Q.class); }
            else if(s=="R"){ findShortest(R.class); }
            else if(s=="S"){ findShortest(S.class); }
            else if(s=="T"){ findShortest(T.class); }
            else if(s=="U"){ findShortest(U.class); }
            else if(s=="V"){ findShortest(V.class); }
            else if(s=="W"){ findShortest(W.class); }
            else if(s=="X"){ findShortest(X.class); }
            else if(s=="Y"){ findShortest(Y.class); }
            else if(s=="Z"){ findShortest(Z.class); }
            else if(s=="E"){ findShortest(E.class); }
            stepFood++;
        }
        else if(step == 3){
            String s = textPac[x][2];
            if(s=="A"){  findShortest(A.class); }
            else if(s=="B"){ findShortest(B.class); }
            else if(s=="C"){ findShortest(C.class); }
            else if(s=="D"){ findShortest(D.class); }
            else if(s=="F"){ findShortest(F.class); }
            else if(s=="G"){ findShortest(G.class); }
            else if(s=="H"){ findShortest(H.class); }
            else if(s=="I"){ findShortest(I.class); }
            else if(s=="J"){ findShortest(J.class); }
            else if(s=="K"){ findShortest(K.class); }
            else if(s=="L"){ findShortest(L.class); }
            else if(s=="M"){ findShortest(M.class); }
            else if(s=="N"){ findShortest(N.class); }
            else if(s=="O"){ findShortest(O.class); }
            else if(s=="P"){ findShortest(P.class); }
            else if(s=="Q"){ findShortest(Q.class); }
            else if(s=="R"){ findShortest(R.class); }
            else if(s=="S"){ findShortest(S.class); }
            else if(s=="T"){ findShortest(T.class); }
            else if(s=="U"){ findShortest(U.class); }
            else if(s=="V"){ findShortest(V.class); }
            else if(s=="W"){ findShortest(W.class); }
            else if(s=="X"){ findShortest(X.class); }
            else if(s=="Y"){ findShortest(Y.class); }
            else if(s=="Z"){ findShortest(Z.class); }
            else if(s=="E"){ findShortest(E.class); }
            stepFood = 1;numAI++;
        }
    }
    
    
    
    private void findShortest(Class s){
       java.util.List<Word> aaa = getWorld().getObjects(s);
       double shortest = 99999;
       int x=0;
        //List s = getObjects(A.class);

       int x1 = getX();int y1 = getY();
       for(x =0;x<aaa.size();x++)
       {
           Word word = aaa.get(x); 
           int x2 = word.getX();int y2 = word.getY();
           double distance = Math.sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
                                         //sss = word;//   move(sss);
           //shortest = distance;
           
           if(distance < shortest){
               shortest = distance;
               sss = word;
            }
          
           
           /*
           if(distance<shortest&&shortest==0)
           {
               shortest = distance;
               sss = word;
               
               if(a.size()==x){
                   move(sss);
                   break;
                }
           }*/
           if(aaa.size()==x+1){
               move(sss);
               break;
           }
       }
       

    }
    
    
    private void motionWalk()
    {
        Point x = new Point(getX(),getY());
        
        //int y = getY();
        if(targetDestination == x){
            setImage("Ghost1.png");
        }else if(targetDestination.getX() > x.getX() || targetDestination.getY() == 0){
            setImage("Ghost1R.png");
        }else if(targetDestination.getX() < x.getX() || targetDestination.getY() == 0){
            setImage("Ghost1L2.png");
        }else if(targetDestination.getX() == 0 || targetDestination.getY() > x.getY()){
            setImage("Ghost1D.png");
        }else if(targetDestination.getX() == 0 || targetDestination.getY() < x.getY()){
            setImage("Ghost1U.png");
        }
        
    }
    
    private void displayScore()
    {
        Actor score1 = new Score(); getWorld().removeObjects(getWorld().getObjectsAt(92,52,Score.class));
        getWorld().addObject(score1, 92, 52);

        score1.setImage(new GreenfootImage(""+totalScore, 25, java.awt.Color.BLACK, null));
    }
    
    public void act() 
    {
        java.util.List<Word> wordInWorld = getWorld().getObjects(Word.class);
                    
        if (!wordInWorld.isEmpty()&&moveToWord&&checkBag()!=7)
        {
            
            Word word = wordInWorld.get(0);
            //move(word);
            //findPath(new Point(word.getX(), word.getY()), new Point(getX(), getY()));
            
            //chooseAI();
            
            chooseWordAI(numAI);
            
            //findShortest(A.class);
            moveToWord = false;
        }
        if (targetDestination.equals(new Point(getX(), getY()))&&moveToWord==false)
        {
            //removeWord();
            eatFood();displayScore();

        }

        if(asdf == 0){
            displayScore();asdf++;
        }
        showWord();
        autoCheckWord();
        motionWalk();
        autoDeleteBag();
        step++;
        
        if (step > 6)
        {
            if (!targetDestination.equals(new Point(getX(), getY()))) // Check to see if already at destination
            {
         
                if (!target) // If not done charting course
                    makePath(); // Chart it
                else
                {
                    setLocation(myRoute.get(routeIndex).getX(), myRoute.get(routeIndex).getY()); // Move to next spot in route
                    routeIndex--; // Next spot
                    
                    if (routeIndex == -1 && getX() == 1 && getY() == 4 && CodeGenerator.haveUser())
                    {
                        getWorld().removeObjects(getWorld().getObjects(CodeDisplay.class));
                        getWorld().addObject(new CodeDisplay(CODE_ID), 1, 4);
                    }
                }
            }
            else
            {
                // If not moving
            }
            step = 0;
        }
        
        if(totalScore>=10&&countaa==0){
            Chart a = (Chart)getWorld();
            a.create();
            countaa++;
        }
        
        // Listen for commands
        
            
    }
    
    private class Square  
    {
        private Point position; // Position of square
        private int parent; // Index of square that is before this one in the route
        private boolean closed = false; // Has not been looked at
        private int g; // Score to get to this position. 100s added for every vertical and horizontal move and 14s for every diagonal move since a diagonal move is a farther move
        private int h; // Score estimate for how many vertical and horizontal moves, regardless of obstacles
    
        public Square(Point position, int parent, int parentG, int thisG, Point destination)
        {
            this.position = position; // Position
            this.parent = parent; // Parent
            g = parentG + thisG; // Parent's score plus score took to get from there to here
            h = (int)(Math.abs(position.getX() - destination.getX()) + Math.abs(position.getY() - destination.getY())) * 100; // Vertical and horizontal spaces between here and destination
        }
        public Point getPosition()
        {
            return position;
        }
        public int getX()
        {
            return (int)position.getX();
        }
        public int getY()
        {
            return (int)position.getY();
        }
        public int getParent()
        {
            return parent;
        }
        public void adopt(int parent)
        {
            this.parent = parent;
        }
        public boolean isClosed()
        {
            return closed;
        }
        public void close()
        {
            closed = true;
        }
        public int getG()
        {
            return g;
        }
        public void changeG(int newG)
        {
            g = newG;
        }
        public int getH()
        {
            return h;
        }
    }
}