import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

public class Score extends Actor
{
    public Score() 
    {
    }
    public Score(int score)
    {
        makeImage(score,30,40);
    }
      public Score(int score, int highScore)
    {
        makeImage(score,30,40);
        makeImage(highScore,30,40);
    }
    private void makeImage(int score, int x , int y)
    {
            GreenfootImage image = new GreenfootImage(73, 70);
            image.setColor(new Color(255,255,255, 0));
            Font font = image.getFont();
            font = font.deriveFont(72.0f);
            image.setFont(font);
            image.setColor(Color.WHITE);
            image.drawString("" + score, x, y);
            setImage(image);
    }
}