import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Chart here.
 * 
 * @author yopachara
 * @version January 2010
 */
public class Chart  extends World
{
    private Logo myLogo = new Logo();
    private boolean started = false;
    private String wordRanPos[] = {"8,5","8,16","52,5","22,5","8,49","8,38","64,49","64,5","50,49","14,28","34,15","40,15","30,10","44,10","53,17","20,17","20,23","53,23","53,34","64,37","23,49","37,24","37,32","20,34","20,40","53,40","29,32","45,32"};
    public boolean wordCheck [] = {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true};
    public String textLine[] = {"C","A","T","B","A","T","A","N","T","P","I","G","R","A","T","B","I","G","R","E","D","A","R","M","C","A","R","L","E","G"};
    Word word = new Word();
    
    public Chart()
    {    
        super(100  , 60, 10);
        GreenfootImage back = new GreenfootImage(10, 10);
        back.fill();
        setBackground(back);
        CodeKeyUser.enter();
        Greenfoot.start();

        prepare();
    }

    public void act()
    {
        
        if (!started )
        {
            addObject(myLogo, 50, 30);
            started = true;
        }
        if (myLogo != null)
            if (myLogo.done())
            {
                removeObject(myLogo);
                myLogo = null;
                addObject(new Player(37,39), 37, 39);
                addObject(new Ghost(37,15), 37, 15);

                //setActOrder(Player.class,Ghost.class,Word.class,Map.class);
                /*
                addObject(new Rock(), 8, 0);
                addObject(new Rock(), 4, 1);
                addObject(new Rock(), 5, 1);
                addObject(new Rock(), 6, 1);
                addObject(new Rock(), 7, 1);
                addObject(new Rock(), 8, 1);
                addObject(new Rock(), 5, 2);
                addObject(new Rock(), 0, 3);
                addObject(new Rock(), 1, 3);
                addObject(new Rock(), 2, 3);
                addObject(new Rock(), 3, 3);
                addObject(new Rock(), 0, 4);
                addObject(new Rock(), 3, 4);
                addObject(new Rock(), 7, 4);
                addObject(new Rock(), 9, 4);
                addObject(new Rock(), 3, 5);
                addObject(new Rock(), 4, 5);
                addObject(new Rock(), 7, 5);
                addObject(new Rock(), 0, 6);
                addObject(new Rock(), 7, 6);
                addObject(new Rock(), 0, 7);
                addObject(new Rock(), 1, 7);
                addObject(new Rock(), 2, 7);
                addObject(new Rock(), 5, 7);
                addObject(new Rock(), 6, 7);
                addObject(new Rock(), 7, 7);
                addObject(new Rock(), 8, 7);
                addObject(new Rock(), 2, 8);
                addObject(new Rock(), 3, 8);
                addObject(new Rock(), 7, 8);
                addObject(new Rock(), 5, 9);
                addObject(new Rock(), 9, 9);
                 */
                addObject(new Map(1,6),26,49);
                addObject(new Map(1,6),47,49);
                addObject(new Map(1,3), 13,47);
                addObject(new Map(1,3), 59,47);
                addObject(new Map(1,17), 37,45);
                addObject(new Map(1,12), 24,42);
                addObject(new Map(1,12), 50,42);
                addObject(new Map(1,2), 20,37);
                addObject(new Map(1,1), 17,37);
                addObject(new Map(2,1), 56,20);
                addObject(new Map(2,2), 53,20);
                addObject(new Map(1,7), 11,40);
                addObject(new Map(1,12), 62,40);
                addObject(new Map(1,5), 24,28);
                addObject(new Map(1,6), 50,28);
                addObject(new Map(2,15), 64,27);
                addObject(new Map(2,1), 56,37);
                addObject(new Map(2,2), 53,37);
                addObject(new Map(1,1), 17,20);
                addObject(new Map(1,2), 20,20);
                addObject(new Map(1,11), 32,20);
                addObject(new Map(1,11), 42,20);
                addObject(new Map(1,3), 27,14);
                addObject(new Map(1,3), 46,14);
                
                addObject(new Map(1,16), 37,28);
                addObject(new Map(1,11), 32,36);
                addObject(new Map(1,11), 42,36);
                
                addObject(new Map(1,3), 19,9);
                
                addObject(new Map(1,3), 46,14);
                //addObject(new Map(1,7), 19,9);
                addObject(new Map(1,3), 54,9);
                addObject(new Map(1,7), 11,13);
                addObject(new Map(1,7), 62,7);
                addObject(new Map(1,12), 62,13);
                addObject(new Map(1,12), 11,7);
                addObject(new Map(1,4), 26,5);
                addObject(new Map(1,4), 47,5);
                addObject(new Map(1,15), 37,8);
                //addObject(new Map(1,18), 5,10);
                //addObject(new Map(1,21), 8,18);
                //addObject(new Map(1,21), 9,18);
                //addObject(new Map(1,20), 11,27);
                //addObject(new Map(1,20), 11,26);
                //addObject(new Map(1,20), 11,25);
                //addObject(new Map(1,21), 8,35);
               // addObject(new Map(1,22), 5,44);
                addObject(new Map(2,17), 36,52);
                addObject(new Map(2,16), 36,2);
                addObject(new Map(2,18), 67,27);
                addObject(new Map(2,18), 6,27);
                addObject(new Map(2,15), 9,27);
                
                //addObject(new A(), 37, 24);
                addObject(new C(), 40, 24);
                addObject(new T(), 34, 24);
                setBackground("playScreen.png");
                addObject(new Timer(),82,55);
                
               
                //{"C","A","T","B","A","T","A","N","T","P","I","G","R","A","T","B","I","G","R","E","D","A","R","M","C","A","R","L","E","G"};
                addObject(new C(),8,5);
                addObject(new A(),8,38);addObject(new I(),34,15);addObject(new E(),64,37);addObject(new L(),14,20);
                addObject(new T(),8,16);addObject(new G(),40,15);addObject(new D(),23,49);addObject(new E(),59,20);
                addObject(new B(),52,5);addObject(new R(),30,10);addObject(new A(),37,24);addObject(new G(),37,49);
                addObject(new A(),22,5);addObject(new A(),44,10);addObject(new R(),37,32);
                addObject(new T(),8,49);addObject(new T(),53,17);addObject(new M(),20,34);
                addObject(new A(),64,48);addObject(new B(),20,17);addObject(new C(),20,40);
                addObject(new N(),64,5);addObject(new I(),20,23);addObject(new A(),53,40);
                addObject(new T(),50,49);addObject(new G(),53,23);addObject(new R(),29,32);
                addObject(new P(),14,28);addObject(new R(),53,34);addObject(new L(),45,32);
               
                
                //"8,5","8,16","52,5","22,5","8,49","8,38","64,49","64,5","50,49","14,28","34,15","40,15","30,10","44,10","53,17","20,17","20,23","53,23",
                //"53,34","64,37","23,49","37,24","37,32","20,34","20,40","53,40","29,32","45,32"};
                //Word word = new Word();
                
                //word.showWord();
                //addObject(new Word(),1,1);
                
                                setActOrder(Player.class,Ghost.class,Word.class,Map.class);
        }
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        CodeKeyUser.enter();
        CodeGenerator.setup();
    }
    public void create(){
         addObject(new A(),8,38);addObject(new T(),34,15);addObject(new S(),64,37);addObject(new B(),14,20);
                    addObject(new I(),8,16);addObject(new E(),40,15);addObject(new E(),23,49);addObject(new O(),59,20);
                    addObject(new R(),52,5);addObject(new A(),30,10);addObject(new A(),37,24);addObject(new W(),37,49);
                    addObject(new A(),22,5);addObject(new S(),44,10);addObject(new I(),37,32);
                    addObject(new R(),8,49);addObject(new I(),53,17);addObject(new C(),20,34);
                    addObject(new T(),64,48);addObject(new N(),20,17);addObject(new E(),20,40);
                    addObject(new B(),64,5);addObject(new G(),20,23);addObject(new A(),53,40);
                    addObject(new U(),50,49);addObject(new A(),53,23);addObject(new R(),29,32);
                    addObject(new S(),14,28);addObject(new S(),53,34);addObject(new L(),45,32);
    }
}