import greenfoot.Actor;
import greenfoot.MouseInfo;
import greenfoot.*;
import java.util.ArrayList;
import java.awt.Point;
import java.util.List;
/**
 * Turtle
 * 
 * @author Taylor Born
 * @version January 20100
 */
public class Player  extends Actor
{
    private ArrayList<Square> sqrList; // Squares that are looked at
    private ArrayList<Square> myRoute; // My charted course
    private int routeIndex; // How far I've gone on my route
    private int parent; // Square that gets me to another square
    private boolean target; // If found destination
    private Point targetDestination; // Where I want to go
    private int step = 0; // Slow down travel speed
    private boolean moveToWord = true;
    int stepFood = 1;
    private int imageCounter=0;
    int setImage=1;
    public int sq;
            int asdf = 0;

    
    private static final int CODE_ID = 71;
    
    public int ghostScore = 0;
    private int foodEaten;
    String[] bag1 = new String[]{null, null, null, null, null, null};  
    boolean[] bag2 = new boolean[]{false,false,false,false,false,false};
    
    public String textPac[][] = {{"C","A","T"},{"B","A","T"},{"A","N","T"},{"P","I","G"},{"R","A","T"},{"B","I","G"},{"R","E","D"},{"A","R","M"},{"C","A","R"},{"L","E","G"}};
    public String textAI[][] = {{"C","A","T"},{"B","A","T"},{"A","N","T"},{"P","I","G"},{"R","A","T"},{"B","I","G"},{"R","E","D"},{"A","R","M"},{"C","A","R"},{"L","E","G"}};
    private boolean checkPac[] = {true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,};
    boolean textPac1[] = {false,false,false,false,false,false,false,false,false,false};
    public String textLine[] = {"C","A","T","B","A","T","A","N","T","P","I","G","R","A","T","B","I","G","R","E","D","A","R","M","C","A","R","L","E","G"};
    boolean checkShow[] = {false,false,false,false,false,false};
    int nowShow[] = {0,0,0,0,0,0};
    Word sss;
    
        private int totalScore;
     // java.util.List<Word> wordInWorld = getWorld().getObjects(Word.class);
    
    public Player(int x, int y)
    {
        targetDestination = new Point(x, y); // Where I want to be
    }
    public Player()
    {
         targetDestination = new Point(this.getX(), this.getY());
    }
    public void findPath(Point pPosition, Point startPosition)
    {
        targetDestination = pPosition; // Get destination
        sqrList = new ArrayList<Square>(); // Refresh my squares to look at
        sqrList.add(new Square(startPosition, -1, 0, 0, targetDestination)); // Add my current position as a square to look at
        target = false; // I have just begun
        parent = 0; // Start at first square
    }
    public void move(int x, int y)
    {
        targetDestination = new Point(x,y);
        Point startPosition = new Point(getX(), getY());
        sqrList = new ArrayList<Square>(); // Refresh my squares to look at
        sqrList.add(new Square(startPosition, -1, 0, 0, targetDestination)); // Add my current position as a square to look at
        target = false; // I have just begun
        parent = 0; // Start at first square
    }
    public void move(Word word)
    {
        int x = word.getX();
        int y = word.getY();
        targetDestination = new Point(x,y);
        Point startPosition = new Point(getX(), getY());
        sqrList = new ArrayList<Square>(); // Refresh my squares to look at
        sqrList.add(new Square(startPosition, -1, 0, 0, targetDestination)); // Add my current position as a square to look at
        target = false; // I have just begun
        parent = 0; // Start at first square
    }
    private void makePath()
    {
        for (int q = 0; q < 50 && !target; q++) // Do so many calculations per act so not to lag other parts of the program
        {
            // Check all squares around the currently looked at square
            // Square to the left
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() - 2, sqrList.get(parent).getY(), Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(-1, 0))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() - 1, sqrList.get(parent).getY()), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square to the upper left
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() - 2, sqrList.get(parent).getY() - 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() - 1 > -1 && sqrList.get(parent).getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(-1, -1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() - 1, sqrList.get(parent).getY() - 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            // Square above
            if (getWorld().getObjectsAt(sqrList.get(parent).getX(), sqrList.get(parent).getY() - 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(0, -1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX(), sqrList.get(parent).getY() - 1), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            // Square to the upper right
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() + 2, sqrList.get(parent).getY() - 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() + 1 < 100 && sqrList.get(parent).getY() - 1 > -1) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(1, -1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() + 1, sqrList.get(parent).getY() - 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() + 2, sqrList.get(parent).getY(), Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(1, 0))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() + 1, sqrList.get(parent).getY()), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() + 2, sqrList.get(parent).getY() + 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() + 1 < 100 && sqrList.get(parent).getY() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(1, 1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() + 1, sqrList.get(parent).getY() + 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX(), sqrList.get(parent).getY() + 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getY() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 100, new Point(0, 1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX(), sqrList.get(parent).getY() + 1), parent, sqrList.get(parent).getG(), 100, targetDestination)); // Add the square, takes 100 points to move horizontally or vertically, and know how many points it has taken to get here
            }
            if (getWorld().getObjectsAt(sqrList.get(parent).getX() - 2, sqrList.get(parent).getY() + 2, Map.class).size() == 0) // Check if no rock
            {
                if (sqrList.get(parent).getX() - 1 > -1 && sqrList.get(parent).getY() + 1 < 100) // Check if in bounds of grid
                    if (!check(parent, 14, new Point(-1, 1))) // Check if already found this square and see if this route is better than one that the square is a part of
                        sqrList.add(new Square(new Point(sqrList.get(parent).getX() - 1, sqrList.get(parent).getY() + 1), parent, sqrList.get(parent).getG(), 14, targetDestination)); // Add the square, takes 14 points to move diagonally, and know how many points it has taken to get here
            }
            sqrList.get(parent).close(); // Done looking at this square
            int lowest = -1; // Index for square that has lowest score
            for (int i = 0; i < sqrList.size(); i++) // Get square that has lowest score
            {
                if (!sqrList.get(i).isClosed()) // Make sure we have not already looked at
                {
                    if (lowest == -1) // If havn't found one yet
                        lowest = i; // This lowest one found so far
                    else if (sqrList.get(i).getG() + sqrList.get(i).getH() < sqrList.get(lowest).getG() + sqrList.get(lowest).getH()) // Check to see if score of this square is the new lowest
                        lowest = i; // This lowest one found so far
                }
            }
            if (lowest == -1) // No possible path
            {
                targetDestination = new Point(getX(), getY());
                return;
            }
            parent = lowest; // Now looking at new lowest
            for (int i = 0; i < sqrList.size(); i++) // Loop all squares that have found
            {
                if (sqrList.get(i).getPosition().equals(targetDestination) && sqrList.get(i).isClosed()) // Check to see if found destination
                {
                    parent = i; // Start at this square to chart back to beginning
                    target = true; // We have found the destination
                }
            }
        }
        if (target) // If found destination
        {
            myRoute = new ArrayList<Square>(); // Refresh route to take
            while (parent != -1) // Loop till back to beginning
            {
                myRoute.add(sqrList.get(parent)); // Add square
                parent = sqrList.get(parent).getParent(); // Move to that square's parent
            }
            routeIndex = myRoute.size() - 2; // When start to move, starting at beginning
        }
    }
    private boolean check(int parent, int cost, Point spot)
    {
        boolean flag = false;
        for (int i = 0; i < sqrList.size(); i++) // Loop squares found
        {
            if (sqrList.get(i).getPosition().equals(new Point((int)(sqrList.get(parent).getX() + spot.getX()), (int)(sqrList.get(parent).getY() + spot.getY())))) // Check if already have the square
            {
                flag = true; // Do have this square
                if (!sqrList.get(i).isClosed() && sqrList.get(parent).getG() + cost < sqrList.get(i).getG()) // Check if new route to square is better
                {
                    sqrList.get(i).adopt(parent); // Change square's parent
                    sqrList.get(i).changeG(sqrList.get(parent).getG() + cost); // Change square's score
                }
            }
        }
        return flag; // return if found that already have square
    }
    public void setLocation(int x, int y)
    {
        if (targetDestination.getX() == getX() && targetDestination.getY() == getY())
            targetDestination = new Point(x, y);
        super.setLocation(x, y);
    }
    
    public void removeWord()
    {
        //getWorld().removeObjects(getWorld().getObjectsAt(Word.class));
        getWorld().removeObjects(getWorld().getObjectsAt(getX(), getY(),Word.class));
        moveToWord = true;
    }
    
    private void eatFood()
    {
        Actor a = getOneObjectAtOffset(0,0, A.class);
        Actor b = getOneObjectAtOffset(0,0, B.class);
        Actor c = getOneObjectAtOffset(0,0, C.class);
        Actor d = getOneObjectAtOffset(0,0, D.class);
        Actor e = getOneObjectAtOffset(0,0, E.class);
        Actor f = getOneObjectAtOffset(0,0, F.class);
        Actor g = getOneObjectAtOffset(0,0, G.class);
        Actor h = getOneObjectAtOffset(0,0, H.class);
        Actor i = getOneObjectAtOffset(0,0, I.class);
        Actor j = getOneObjectAtOffset(0,0, J.class);
        Actor k = getOneObjectAtOffset(0,0, K.class);
        Actor l = getOneObjectAtOffset(0,0, L.class);
        Actor m = getOneObjectAtOffset(0,0, M.class);
        Actor n = getOneObjectAtOffset(0,0, N.class);
        Actor o = getOneObjectAtOffset(0,0, O.class);
        Actor p = getOneObjectAtOffset(0,0, P.class);
        Actor q = getOneObjectAtOffset(0,0, Q.class);
        Actor r = getOneObjectAtOffset(0,0, R.class);
        Actor s = getOneObjectAtOffset(0,0, S.class);
        Actor t = getOneObjectAtOffset(0,0, T.class);
        Actor u = getOneObjectAtOffset(0,0, U.class);
        Actor v = getOneObjectAtOffset(0,0, V.class);
        Actor w = getOneObjectAtOffset(0,0, W.class);
        Actor x = getOneObjectAtOffset(0,0, X.class);
        Actor y = getOneObjectAtOffset(0,0, Y.class);
        Actor z = getOneObjectAtOffset(0,0, Z.class);
        ghostScore=foodEaten+ghostScore;
        Chart paw=(Chart) getWorld();
        int bagLeft = checkBag();
        
        
        if(a!=null) { if(bagLeft<7){getWorld().removeObject(a);collectAlphabet(bagLeft,"a","A");foodEaten = foodEaten+5;}}
        else if(b!=null) { if(bagLeft<7){getWorld().removeObject(b);collectAlphabet(bagLeft,"b","B");foodEaten = foodEaten+5;}}
        else if(c!=null) { if(bagLeft<7){getWorld().removeObject(c);collectAlphabet(bagLeft,"c","C");foodEaten = foodEaten+5;}}
        else if(d!=null) { if(bagLeft<7){getWorld().removeObject(d);collectAlphabet(bagLeft,"d","D");foodEaten = foodEaten+5;}}
        else if(e!=null) { if(bagLeft<7){getWorld().removeObject(e);collectAlphabet(bagLeft,"e","E");foodEaten = foodEaten+5;}}
        else if(f!=null) { if(bagLeft<7){getWorld().removeObject(f);collectAlphabet(bagLeft,"f","F");foodEaten = foodEaten+5;}}
        else if(g!=null) { if(bagLeft<7){getWorld().removeObject(g);collectAlphabet(bagLeft,"g","G");foodEaten = foodEaten+5;}}
        else if(h!=null) { if(bagLeft<7){getWorld().removeObject(h);collectAlphabet(bagLeft,"h","H");foodEaten = foodEaten+5;}}
        else if(i!=null) { if(bagLeft<7){getWorld().removeObject(i);collectAlphabet(bagLeft,"i","I");foodEaten = foodEaten+5;}}
        else if(j!=null) { if(bagLeft<7){getWorld().removeObject(j);collectAlphabet(bagLeft,"j","J");foodEaten = foodEaten+5;}}
        else if(k!=null) { if(bagLeft<7){getWorld().removeObject(k);collectAlphabet(bagLeft,"k","K");foodEaten = foodEaten+5;}}
        else if(l!=null) { if(bagLeft<7){getWorld().removeObject(l);collectAlphabet(bagLeft,"l","L");foodEaten = foodEaten+5;}}
        else if(m!=null) { if(bagLeft<7){getWorld().removeObject(m);collectAlphabet(bagLeft,"m","M");foodEaten = foodEaten+5;}}
        else if(n!=null) { if(bagLeft<7){getWorld().removeObject(n);collectAlphabet(bagLeft,"n","N");foodEaten = foodEaten+5;}}
        else if(o!=null) { if(bagLeft<7){getWorld().removeObject(o);collectAlphabet(bagLeft,"o","O");foodEaten = foodEaten+5;}}
        else if(p!=null) { if(bagLeft<7){getWorld().removeObject(p);collectAlphabet(bagLeft,"p","P");foodEaten = foodEaten+5;}}
        else if(q!=null) { if(bagLeft<7){getWorld().removeObject(q);collectAlphabet(bagLeft,"q","Q");foodEaten = foodEaten+5;}}
        else if(r!=null) { if(bagLeft<7){getWorld().removeObject(r);collectAlphabet(bagLeft,"r","R");foodEaten = foodEaten+5;}}
        else if(s!=null) { if(bagLeft<7){getWorld().removeObject(s);collectAlphabet(bagLeft,"s","S");foodEaten = foodEaten+5;}}
        else if(t!=null) { if(bagLeft<7){getWorld().removeObject(t);collectAlphabet(bagLeft,"t","T");foodEaten = foodEaten+5;}}
        else if(u!=null) { if(bagLeft<7){getWorld().removeObject(u);collectAlphabet(bagLeft,"u","U");foodEaten = foodEaten+5;}}
        else if(v!=null) { if(bagLeft<7){getWorld().removeObject(v);collectAlphabet(bagLeft,"v","V");foodEaten = foodEaten+5;}}
        else if(w!=null) { if(bagLeft<7){getWorld().removeObject(w);collectAlphabet(bagLeft,"w","W");foodEaten = foodEaten+5;}}
        else if(x!=null) { if(bagLeft<7){getWorld().removeObject(x);collectAlphabet(bagLeft,"x","X");foodEaten = foodEaten+5;}}
        else if(y!=null) { if(bagLeft<7){getWorld().removeObject(y);collectAlphabet(bagLeft,"y","Y");foodEaten = foodEaten+5;}}
        else if(z!=null) { if(bagLeft<7){getWorld().removeObject(z);collectAlphabet(bagLeft,"z","Z");foodEaten = foodEaten+5;}}
        else {
            
        }
        
                    moveToWord = true;

    }
    
    private int checkBag(){
        if(bag2[0] == false){
            return 0;
        }
        else if(bag2[1] == false){
            return 1;
        }
        else if(bag2[2] == false){
            return 2;
        }
        else if(bag2[3] == false){
            return 3;
        }
        else if(bag2[4] == false){
            return 4;
        }
        else if(bag2[5] == false){
            return 5;
        }else
        return 7;
                    
    }
    
    private void collectAlphabet(int num,String asd,String orderAlphabet){
        switch(num+1){
                    case 1: getWorld().addObject(new WordFake(asd), 23, 56);
                            bag1[0] = orderAlphabet;
                            bag2[0] = true;
                    break;
                    case 2: getWorld().addObject(new WordFake(asd), 29, 56);
                            bag1[1] = orderAlphabet;
                            bag2[1] = true;
                    break;
                    case 3: getWorld().addObject(new WordFake(asd), 35, 56);
                            bag1[2] = orderAlphabet;
                            bag2[2] = true;
                    break;
                    case 4: getWorld().addObject(new WordFake(asd), 41, 56);
                            bag1[3] = orderAlphabet;
                            bag2[3] = true;
                    break;
                    case 5: getWorld().addObject(new WordFake(asd), 46, 56);
                            bag1[4] = orderAlphabet;
                            bag2[4] = true;
                    break;
                    case 6: getWorld().addObject(new WordFake(asd), 52, 56);
                            bag1[5] = orderAlphabet;
                            bag2[5] = true;
                    break;
        }

    }
    
    private void dropAlphabet(int x){
        //List fruit; 
        //Actor sq;
        //sq = getOneObjectAtOffset(0,0,Sq.class);
        
        //fruit = getOneObjectAtOffset(0,0, Sq.class);
        //Player py1 = new Player();
        //if(bag.get(x-1) != null){
            //isEat = false;
        //if(Fruit != null){
        //if(sq != null){        
        bag1[x] = null;
        bag2[x] = false;
            //getWorld().removeObjects(fruit);
            
       switch(x+1){
           case 1:
           getWorld().removeObjects(getWorld().getObjectsAt(23, 56,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 2:
           getWorld().removeObjects(getWorld().getObjectsAt(29, 56,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 3:
           getWorld().removeObjects(getWorld().getObjectsAt(35, 56,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 4:
           getWorld().removeObjects(getWorld().getObjectsAt(41, 56,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 5:
           getWorld().removeObjects(getWorld().getObjectsAt(46, 56,WordFake.class));
           foodEaten = foodEaten-10;
           break;
           case 6:
           getWorld().removeObjects(getWorld().getObjectsAt(52, 56,WordFake.class));
           foodEaten = foodEaten-10;
           break;
       }
       // }
                
            //getWorld().addObject(new Fruit(), getX(),getY());
        //}
            //cooldown(5);
        //}
    }
    
    public void checkWord(String p,String q,String r,int d){
        for(int x=0; x<bag1.length; x++) {
            if(bag1[x] == p){
            
                for(int y=0; y<bag1.length;y++){
                    
                    if(bag1[y] == q){
                    
                        for(int z=0; z<bag1.length;z++){
                            if(bag1[z] == r){
                                dropAlphabet(x);dropAlphabet(y);dropAlphabet(z);dropWord(d);checkShow[d] = false;
                                totalScore = totalScore+1;
                                displayScore();
                            }
                        }
                    }
               }
            }
       } 
       
    }
    
    private void showWord(){
        int showLeft = checkShow();
        int wordLeft = checkWordLeft();
        if(showLeft >= 0&&wordLeft>=0){
            switch(showLeft+1){
                case 1:
                //show text
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[0] = wordLeft;
                
                //TextBar
                //getWorld().addObject(new TextBar(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2]),850,160);
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],83,16);
                break;
                
                case 2:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[1] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],83,21);
                break;
                
                case 3:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[2] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],83,26);
                break;
                
                case 4:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[3] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],83,31);
                break;
                
                case 5:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[4] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],83,36);
                break;
                
                case 6:
                checkShow[showLeft] = true;
                textPac1[wordLeft] = true;
                nowShow[5] = wordLeft;
                getWorld().showText(textPac[wordLeft][0]+textPac[wordLeft][1]+textPac[wordLeft][2],83,41);
                break;
            }
        }
        
    }
    
    private int checkShow(){
        for(int x=0;x<checkShow.length;x++){
            if(checkShow[x] == false){
                return x;
            }
        }
        return -1;
    }
    
    private boolean checkNow(int x){
        if(checkShow[x] == true){
            return true;
        }
        return false;
    }
    
    private int checkWordLeft(){
        for(int x=0;x<textPac1.length;x++){
            if(textPac1[x] == false){
                return x;
            }
        }
        return -1;
    }
    
    public void autoCheckWord(){
        if(checkShow[0] == true ){
            checkWord(textPac[nowShow[0]][0],textPac[nowShow[0]][1],textPac[nowShow[0]][2],0);
            //checkWord(textPac[nowShow[1]][0],textPac[nowShow[1]][1],textPac[nowShow[1]][2],1);
            //checkShow[0] = false;
        }
        if(checkShow[1] == true ){
            checkWord(textPac[nowShow[1]][0],textPac[nowShow[1]][1],textPac[nowShow[1]][2],1);
            //checkShow[1]= false;
        }
        if(checkShow[2] == true ){
            checkWord(textPac[nowShow[2]][0],textPac[nowShow[2]][1],textPac[nowShow[2]][2],2);
            //checkShow[2]= false;
        }
        if(checkShow[3] == true ){
            checkWord(textPac[nowShow[3]][0],textPac[nowShow[3]][1],textPac[nowShow[3]][2],3);
            //checkShow[3]= false;
        }
        if(checkShow[4] == true ){
            checkWord(textPac[nowShow[4]][0],textPac[nowShow[4]][1],textPac[nowShow[4]][2],4);
            //checkShow[4]= false;
        }
        if(checkShow[5] == true ){
            checkWord(textPac[nowShow[5]][0],textPac[nowShow[5]][1],textPac[nowShow[5]][2],5);
            //checkShow[5]= false;
        }
    }
    
    public void dropWord(int x){
        switch(x+1){
           case 1:
           getWorld().showText(" ",83,16);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,160,null));
           break;
           case 2:
           getWorld().showText(" ",83,21);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,210,null));
           break;
           case 3:
           getWorld().showText(" ",83,26);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,360,null));
           break;
           case 4:
           getWorld().showText(" ",83,31);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,410,null));
           break;
           case 5:
           getWorld().showText(" ",83,36);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,460,null));
           break;
           case 6:
           getWorld().showText(" ",83,41);
           //getWorld().removeObjects(getWorld().getObjectsAt(850,510,null));
           break;
       }
    }
    
    
    
    
    private void motionWalk()
    {
        Point x = new Point(getX(),getY());
        
        //int y = getY();
        if(targetDestination == x){
            setImage("fairy_02.png");
        }else if(targetDestination.getX() > x.getX() || targetDestination.getY() == 0){
            motionImage(2);
        }else if(targetDestination.getX() < x.getX() || targetDestination.getY() == 0){
            motionImage(1);
        }else if(targetDestination.getX() == 0 || targetDestination.getY() > x.getY()){
            motionImage(4);
        }else if(targetDestination.getX() == 0 || targetDestination.getY() < x.getY()){
            motionImage(3);
        }
        
    }
    
    private void motionImage(int ID)
    {

        switch(ID){
            case 1: if(imageCounter==10) {
                        if(setImage==1) {
                        setImage("fairy_04.png"); setImage=2;
                    }
                    else if(setImage==2) {
                        setImage("fairy_05.png"); setImage=3;
                    }
                    else if(setImage==3) {
                        setImage("fairy_06.png"); setImage=1;
                    }
                    imageCounter=0;
                    }
                    else imageCounter=imageCounter+1;
                    break;
            case 2:if(imageCounter==10) {
                        if(setImage==1) {
                        setImage("fairy_07.png"); setImage=2;
                    }
                    else if(setImage==2) {
                        setImage("fairy_08.png"); setImage=3;
                    }
                    else if(setImage==3) {
                        setImage("fairy_09.png"); setImage=1;
                    }
                    imageCounter=0;
                    }
                    else imageCounter=imageCounter+1;
                    break;
            case 3:if(imageCounter==10) {
                        if(setImage==1) {
                        setImage("fairy_10.png"); setImage=2;
                    }
                    else if(setImage==2) {
                        setImage("fairy_11.png"); setImage=3;
                    }
                    else if(setImage==3) {
                        setImage("fairy_12.png"); setImage=1;
                    }
                    imageCounter=0;
                    }
                    else imageCounter=imageCounter+1;
                    break;
            case 4:if(imageCounter==10) {
                        if(setImage==1) {
                        setImage("fairy_01.png"); setImage=2;
                    }
                    else if(setImage==2) {
                        setImage("fairy_02.png"); setImage=3;
                    }
                    else if(setImage==3) {
                        setImage("fairy_03.png"); setImage=1;
                    }
                    imageCounter=0;
                    }
                    else imageCounter=imageCounter+1;
                    break;
                    
                    
        }
    }
    
    private void displayScore()
    {
        Actor score2 = new Score(); getWorld().removeObjects(getWorld().getObjectsAt(84,52,Score.class));
        getWorld().addObject(score2, 84,52);

        score2.setImage(new GreenfootImage(""+totalScore, 25, java.awt.Color.BLACK, null));
    }
    
    public void act() 
    {
        
        if(Greenfoot.isKeyDown("space")){
            eatFood();
        }
        
        showWord();
        autoCheckWord();
        motionWalk();

        if(asdf == 0){
            displayScore();asdf++;
        }
        
        step++;
        if (step > 6)
        {
            if (!targetDestination.equals(new Point(getX(), getY()))) // Check to see if already at destination
            {
         
                if (!target) // If not done charting course
                    makePath(); // Chart it
                else
                {
                    setLocation(myRoute.get(routeIndex).getX(), myRoute.get(routeIndex).getY()); // Move to next spot in route
                    routeIndex--; // Next spot
                    
                    if (routeIndex == -1 && getX() == 1 && getY() == 4 && CodeGenerator.haveUser())
                    {
                        getWorld().removeObjects(getWorld().getObjects(CodeDisplay.class));
                        getWorld().addObject(new CodeDisplay(CODE_ID), 1, 4);
                    }
                }
            }
            else
            {
                // If not moving
            }
            step = 0;
        }
        
        // Listen for commands
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (Greenfoot.mousePressed(getWorld()))
            findPath(new Point(mouse.getX(), mouse.getY()), new Point(getX(), getY()));
            
        if(Greenfoot.isKeyDown("x")){
            dropAlphabet(sq);
        }
        
        if(Greenfoot.isKeyDown("1")){
            getWorld().removeObjects(getWorld().getObjects(Sq.class));
            getWorld().addObject(new Sq(),10, 56);
            sq = 0;
        }
        if(Greenfoot.isKeyDown("2")){
            getWorld().removeObjects(getWorld().getObjects(Sq.class));
            getWorld().addObject(new Sq(),19, 56);
            sq = 1;
        }
        if(Greenfoot.isKeyDown("3")){
            getWorld().removeObjects(getWorld().getObjects(Sq.class));
            getWorld().addObject(new Sq(),28, 56);
            sq = 2;
        }
        if(Greenfoot.isKeyDown("4")){
            getWorld().removeObjects(getWorld().getObjects(Sq.class));
            getWorld().addObject(new Sq(),37, 56);
            sq = 3;
        }
        if(Greenfoot.isKeyDown("5")){
            getWorld().removeObjects(getWorld().getObjects(Sq.class));
            getWorld().addObject(new Sq(),47, 56);
            sq = 4;
        }
        if(Greenfoot.isKeyDown("6")){
            getWorld().removeObjects(getWorld().getObjects(Sq.class));
            getWorld().addObject(new Sq(),56, 56);
            sq = 5;
        }
            
    }
    
    private class Square  
    {
        private Point position; // Position of square
        private int parent; // Index of square that is before this one in the route
        private boolean closed = false; // Has not been looked at
        private int g; // Score to get to this position. 100s added for every vertical and horizontal move and 14s for every diagonal move since a diagonal move is a farther move
        private int h; // Score estimate for how many vertical and horizontal moves, regardless of obstacles
    
        public Square(Point position, int parent, int parentG, int thisG, Point destination)
        {
            this.position = position; // Position
            this.parent = parent; // Parent
            g = parentG + thisG; // Parent's score plus score took to get from there to here
            h = (int)(Math.abs(position.getX() - destination.getX()) + Math.abs(position.getY() - destination.getY())) * 100; // Vertical and horizontal spaces between here and destination
        }
        public Point getPosition()
        {
            return position;
        }
        public int getX()
        {
            return (int)position.getX();
        }
        public int getY()
        {
            return (int)position.getY();
        }
        public int getParent()
        {
            return parent;
        }
        public void adopt(int parent)
        {
            this.parent = parent;
        }
        public boolean isClosed()
        {
            return closed;
        }
        public void close()
        {
            closed = true;
        }
        public int getG()
        {
            return g;
        }
        public void changeG(int newG)
        {
            g = newG;
        }
        public int getH()
        {
            return h;
        }
    }
}